Description

When changing the attributes of an issue from the context menu, the bulk update issues path is used even if only one issue is

selected. Because of this, if the validation fails, the user is redirect to the bulk edit view to fill in the required fields. But if Description

is one of those fields, the user won't have available the field because Description is not available in the bulk edit view.

The attach patch changes the behaviour in order to use issue path to update attributes when only one issue is selected. In this case,

if the validation fails, the user is redirect to the issue edit page. The route change was necessary in order to allow Patch method for

bulk routes as well.

Associated revisions

Revision 21089 - 2021-07-26 23:46 - Marius BĂLTEANU

Use issue path instead of bulk update issues path when only one issue is selected in the context menu (#33521).

Revision 21132 - 2021-08-03 22:21 - Marius BĂLTEANU

Fix update status path on the context menu (#33521).

Patch by Mizuki ISHIKAWA.

Revision 21133 - 2021-08-03 22:25 - Marius BĂLTEANU

Update custom field path on the context menu (#33521).

Patch by Mizuki ISHIKAWA.

Revision 21139 - 2021-08-06 01:41 - Marius BĂLTEANU

Fix that updating an issue from context menu to a none value do not set the field to blank (#33521).

Patch by Mizuki ISHIKAWA.

Revision 21140 - 2021-08-06 01:46 - Marius BĂLTEANU

Fix typo (#33521).

History

#1 - 2020-05-28 17:51 - Marius BĂLTEANU

All tests pass: https://gitlab.com/redmine-org/redmine/pipelines/150020738

#2 - 2020-06-02 14:35 - Go MAEDA

Would you tell me the steps to cause a validation error through the context menu? Since the context menu only shows valid options, I could not find a

way to cause a validation error.

#3 - 2020-06-13 18:40 - Marius BĂLTEANU

Go MAEDA wrote:

Would you tell me the steps to cause a validation error through the context menu? Since the context menu only shows valid options, I could not

find a way to cause a validation error.

Yes, please follow these steps using the default data:
1. Make "Description" field mandatory for "In progress" status

2. Find an issue in status "New" without "Description" filled in

3. Using the context menu, try to change the issue status to in "In progress"

4. You should receive the validation error and you can observe that the Description field is not available in the page.

#4 - 2020-06-14 04:13 - Go MAEDA

Marius BALTEANU wrote:

Go MAEDA wrote:

Would you tell me the steps to cause a validation error through the context menu? Since the context menu only shows valid options, I could

not find a way to cause a validation error.

Yes, please follow these steps using the default data:

1. Make "Description" field mandatory for "In progress" status

2. Find an issue in status "New" without "Description" filled in

3. Using the context menu, try to change the issue status to in "In progress"

4. You should receive the validation error and you can observe that the Description field is not available in the page.

 Thank you, confirmed the issue.

#5 - 2020-10-05 22:41 - Marius BĂLTEANU

- Target version changed from Candidate for next major release to 4.2.0

#6 - 2021-03-23 21:40 - Marius BĂLTEANU

- Tracker changed from Patch to Defect

- Status changed from New to Confirmed

- Target version changed from 4.2.0 to 5.0.0

#7 - 2021-07-04 17:31 - Marius BĂLTEANU

- File 0001-Use-issue-path-instead-of-bulk-update-issues-path-wh.patch added

Updated the patch.

#8 - 2021-07-26 23:47 - Marius BĂLTEANU

- Status changed from Confirmed to Closed

- Resolution set to Fixed

Patch committed.

#9 - 2021-08-02 03:04 - Go MAEDA

- Status changed from Closed to Reopened

Due to r21089, you are no longer able to change the issue status via the context menu. The error is as follows:

Started POST "/issues/1?back_url=%2Fprojects%2Fecookbook%2Fissues&ids%5B%5D=1&issue%5Bstatus_id%5D=5" for 127.

0.0.1 at 2021-08-02 09:55:03 +0900

ActionController::RoutingError (No route matches [POST] "/issues/1"):

#10 - 2021-08-02 04:41 - Mizuki ISHIKAWA

- File 0001-Fix-status-update-path-on-the-context-menu.patch added

- File 0002-Change-custom-field-value-update-path-on-the-context.patch added

I have attached two patches.

0001-Fix-status-update-path-on-the-context-menu.patch

The cause of #33521#note-9 is that the data method of the link to update the status was still post instead of patch.

This is a patch that adds data-method fixes and tests.

0002-Change-custom-field-value-update-path-on-the-context.patch
Change ContextMenusHelper#bulk_update_custom_field_context_menu_link( 

https://www.redmine.org/projects/redmine/repository/revisions/20846/entry/trunk/app/helpers/context_menus_helper.rb#L37 )  in the same way

as r21089.

#11 - 2021-08-03 22:26 - Marius BĂLTEANU

- Status changed from Reopened to Closed

- Assignee set to Marius BĂLTEANU

Both patches committed, thank you for working on this.

#12 - 2021-08-04 07:20 - Mizuki ISHIKAWA

I found another problem caused by the impact of this change.

When changing the category to none from the context menu:

[Expected result] "Category deleted (Printing)" is displayed in the issue history.

[Actual result] "Category changed from Printing to 0" is displayed in the issue history.

This can be reproduced with attributes other than category_id.

When I pass the parameter {category_id:'none'}, bulk_update converts it to {category_id:''} by the parse_params_for_bulk_update method, but update

doesn't.

https://redmine.org/projects/redmine/repository/revisions/21012/entry/trunk/app/controllers/application_controller.rb#L416

#13 - 2021-08-04 09:23 - Marius BĂLTEANU

- Status changed from Closed to Reopened

#14 - 2021-08-04 10:54 - Mizuki ISHIKAWA

- File diff.patch added

I have attached a patch to fix #33521#note-12.

#15 - 2021-08-06 01:41 - Marius BĂLTEANU

- Status changed from Reopened to Closed

Mizuki ISHIKAWA wrote:

I have attached a patch to fix #33521#note-12.

 Patch committed with small changes, thank you for reporting and fixing the issue.

#16 - 2021-08-06 01:49 - Mizuki ISHIKAWA

Marius BALTEANU wrote:

Mizuki ISHIKAWA wrote:

I have attached a patch to fix #33521#note-12.

 Patch committed with small changes, thank you for reporting and fixing the issue.

 Thank you for reviewing and committing.

Files

0001-Use-issue_path-when-only-one-issue-is-modified-from-.patch 12.6 KB 2020-05-28 Marius BĂLTEANU

0001-Use-issue-path-instead-of-bulk-update-issues-path-wh.patch 12.3 KB 2021-07-04 Marius BĂLTEANU

0002-Change-custom-field-value-update-path-on-the-context.patch 5.63 KB 2021-08-02 Mizuki ISHIKAWA

0001-Fix-status-update-path-on-the-context-menu.patch 4.49 KB 2021-08-02 Mizuki ISHIKAWA

diff.patch 3.13 KB 2021-08-04 Mizuki ISHIKAWA
